# PetscCall

This package provides easy access to PETSc solvers in sequential and parallel Julia computations. See documentation for further details.


| **Documentation** |
|:------------ |
| [![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://fverdugo.github.io/PetscCall.jl/stable/) |
| [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://fverdugo.github.io/PetscCall.jl/dev/) |
|**Build Status** |
[![Build Status](https://github.com/fverdugo/PetscCall.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/fverdugo/PetscCall.jl/actions/workflows/CI.yml?query=branch%3Amain) |
|**Coverage** |
| [![Coverage](https://codecov.io/gh/fverdugo/PetscCall.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/fverdugo/PetscCall.jl) |

## Documentation

- [**STABLE**](https://fverdugo.github.io/PetscCall.jl/stable) &mdash; **Documentation for the most recently tagged version.**
- [**LATEST**](https://fverdugo.github.io/PetscCall.jl/dev) &mdash; *Documentation for the in-development version.*

## Help and discussion

- You can open a new discussion to ask questions [here](https://github.com/fverdugo/PetscCall.jl/discussions).
- If you have found a bug, open an issue [here](https://github.com/fverdugo/PetscCall.jl/issues). Do not forget to include a (minimal) reproducer.

## Contributing

This package is under active development and there are several ways to contribute:

- by enhancing the documentation (e.g., fixing typos, enhancing doc strings, adding examples).
- by addressing one of the [issues waiting for help](https://github.com/fverdugo/PetscCall.jl/labels/help%20wanted).
- by adding more tests to increase the code coverage.
- by extending the current functionality. In this case, open a discussion [here](https://github.com/fverdugo/PetscCall.jl/discussions) to coordinate with the package maintainers before proposing significant changes.
